<template>
  <div>
    <h2 class="text-center text-2xl uppercase tracking-widest mb-6">
      {{ tableName }}
    </h2>
    <div class="container shadow p-4 border-b border-gray-200 sm:rounded-lg bg-slate-100">
      <div class="flex items-center mb-2">
        <!-- Search Input -->
        <input type="text" placeholder="Search..." v-model="searchQuery"
          class="py-2 px-4 border border-gray-300 rounded-l-md focus:outline-none focus:ring focus:border-blue-300" />

        <!-- Search Button -->
        <button type="button"
          class="bg-blue-500 text-white px-4 py-2 rounded-r-md hover:bg-blue-600 focus:outline-none focus:ring focus:border-blue-300"
          disabled>
          <Icon name="material-symbols:search" />
        </button>
      </div>
      <div class="overflow-hidden">
        <table class="min-w-full">
          <thead class="bg-gray-200">
            <tr>
              <th v-for="head in heads" @click="sortBy(head)"
                class="text-left px-2 py-1 text-gray-600 uppercase tracking-wider hover:cursor-pointer hover:bg-slate-300">
                {{ head.name }}
                <Icon :name="isSorted(head.sort)" />
              </th>
            </tr>
          </thead>
          <tbody class="bg-white">
            <tr v-for="(item, index) in items" :key="item.id" :class="{ 'bg-gray-100': index % 2 === 0 }">
              <td>{{ index + 1 }}</td>
              <template v-for="cell in item">
                <template v-if="cell !== item.id">
                  <td v-if="(typeof cell) !== (typeof {})" class="px-2 py-2 whitespace-no-wrap">
                    {{ cell }}
                  </td>
                  <td v-else class="flex">
                    <template v-for="btn in cell">
                      <NuxtLink v-if="btn.route" :href="btn.route" :class="`${btn.color} ${btn.disabled ? 'hidden' : ''}`"
                        class="text-white my-1 mx-1 p-2 rounded hover:cursor-pointer">
                        <Icon :name="btn.icon" />
                      </NuxtLink>
                      <NuxtLink v-else @click="$emit(btn.callback, btn.params ? btn.params : item.id)"
                        :class="`${btn.color} ${btn.disabled ? 'hidden' : ''}`"
                        class="text-white my-1 mx-1 p-2 rounded hover:cursor-pointer">
                        <Icon :name="btn.icon" />
                      </NuxtLink>
                    </template>
                  </td>
                </template>
              </template>
            </tr>
          </tbody>
        </table>
        <div class="flex w-full justify-between">
          <div class="flex items-center justify-left space-x-4 m-4">
            <button @click="prevPage" :disabled="currentPage === 1"
              class="bg-blue-500 text-white px-3 py-2 rounded disabled:opacity-50 active:bg-blue-700 hover:bg-blue-600 hover:cursor-pointer">
              <Icon class="w-full h-full" :name="'material-symbols:skip-previous-rounded'" />
            </button>
            <span class="text-lg text-gray-600 uppercase tracking-wider">{{
              currentPage
            }}</span>
            <button @click="nextPage" :disabled="items.length !== limitPerPage"
              class="bg-blue-500 text-white px-3 py-2 rounded disabled:opacity-50 active:bg-blue-700 hover:bg-blue-600 hover:cursor-pointer">
              <Icon class="w-full h-full" :name="'material-symbols:skip-next-rounded'" />
            </button>
          </div>
          <div class="flex items-center justify-right space-x-4 m-4">
            <NuxtLink v-if="addPath" @click="$router.push(addPath)"
              class="bg-blue-500 text-white px-3 py-2 rounded disabled:opacity-50 active:bg-blue-700 hover:bg-blue-600 hover:cursor-pointer">
              <Icon class="w-full h-full" :name="'material-symbols:add-box-rounded'" />
            </NuxtLink>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  props: {
    tableName: String,
    addPath: {
      type: [String, null],
      default: null,
    },
    currentPage: Number,
    limitPerPage: Number,
    heads: Array,
    items: Array,
  },
  data() {
    return {
      searchQuery: '',
      timer: null
    };
  },
  watch: {
    searchQuery(newVal, oldVal) {
      if (this.timer) {
        clearTimeout(this.timer);
      }

      this.timer = setTimeout(() => {
        console.log(newVal)
        this.$emit('on-search', newVal);
      }, 250);
    }
  },
  methods: {
    sortBy(head) {
      this.$emit("sort-by", head);
    },
    isSorted: (sort) => {
      return sort === 'asc' ? 'mdi:arrow-up-thin' : sort === 'desc' ? 'mdi:arrow-down-thin' : '';
    },
    prevPage() {
      if (this.currentPage !== undefined && this.currentPage > 1) {
        this.$emit("page-change", this.currentPage - 1);
      }
    },
    nextPage() {
      if (this.items !== undefined && this.currentPage !== undefined && this.items.length === this.limitPerPage)
        this.$emit("page-change", this.currentPage + 1);
    },
  },
};
</script>
